//+------------------------------------------------------------------+
//|                                                    SafeHedge.mq4 |
//|                      Copyright  2007, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"


//---- input parameters
extern string    Hedge1="EURUSD";
extern string    Hedge2="USDCHF";
extern double    LotSize=0.1;
extern int       TakeProfit=15;
extern int       StopLoss=25;
extern string    Hedge3="GBPUSD";
extern string    Hedge4="USDJPY";
extern bool      UseHedge1=true;
extern bool      UseHedge2=true;
extern bool      UseHedge3=false;
extern bool      UseHedge4=false;
extern int       MagicNumber=12345;

bool startErrors=false;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   startErrors = placeNewOrders();
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
   while (startErrors == false)
   {
      if (getProfitStatus() == 1)
      {
         tryAgain();
         Sleep(1000);
         startErrors = placeNewOrders();
      }
      if (getStopLossStatus() == 1)
      {
         tryAgain();
         Sleep(1000);
         startErrors = placeNewOrders();
      }
   }
   
//----
   return(0);
  }
//+------------------------------------------------------------------+

int getProfitStatus()
{
      int orders = OrdersTotal();
      //double eur_profit = 0.0;
      //double chf_profit = 0.0; 
      double total = 0;
         
      for (int i=0; i<orders; i++)
      {
         OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
         total += OrderProfit();
      }
      
      double pipProfit = TakeProfit * 10 * LotSize;
      if (total >= pipProfit)
      {
         return (1);
      }
      else
      {
         return (0);
      }
}

int getStopLossStatus()
{
      int orders = OrdersTotal();
      //double eur_profit = 0.0;
      //double chf_profit = 0.0; 
      double total = 0;
         
      for (int i=0; i<orders; i++)
      {
         OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
         total += OrderProfit();
      }
      
      double pipLoss = StopLoss * 10 * LotSize;
      if (total <= pipLoss)
      {
         return (1);
      }
      else
      {
         return (0);
      }
}

bool placeNewOrders()
{
   if (UseHedge1)
   {
      if (OrderSend(Hedge1,OP_BUY,LotSize,MarketInfo(Hedge1,MODE_ASK),3,0,0,"Hedge1 Buy Order",MagicNumber,0, Blue) <= 0)
      {
          MessageBox("Error Hedge1 Buy Order " + GetLastError(), NULL, EMPTY);
          return (true);
      }
   }
   if (UseHedge2)
   {
      if (OrderSend(Hedge2,OP_BUY,LotSize,MarketInfo(Hedge2,MODE_ASK),3,0,0,"Hedge2 Buy Order",MagicNumber+1,0, Blue) <= 0)
      {
          MessageBox("Error Hedge2 Buy Order " + GetLastError(), NULL, EMPTY);
          return (true);
      }
   }
   if (UseHedge3)
   {
      if (OrderSend(Hedge3,OP_BUY,LotSize,MarketInfo(Hedge3,MODE_ASK),3,0,0,"Hedge3 Buy Order",MagicNumber+2,0, Blue) <= 0)
      {
          MessageBox("Error Hedge3 Buy Order " + GetLastError(), NULL, EMPTY);
          return (true);
      }
   }
   if (UseHedge4)
   {
      if (OrderSend(Hedge4,OP_BUY,LotSize,MarketInfo(Hedge4,MODE_ASK),3,0,0,"Hedge4 Buy Order",MagicNumber+3,0, Blue) <= 0)
      {
          MessageBox("Error Hedge4 Buy Order " + GetLastError(), NULL, EMPTY);
          return (true);
      }
   }
   return (false);
}

int tryAgain()
  {
   bool doItAgain = false;
   int total = OrdersTotal();
   //MessageBox("Order totals = " + total,NULL, EMPTY);
   for (int k=0; k<total; k++)
   {
      OrderSelect(k,SELECT_BY_POS, MODE_TRADES);
      int type = OrderType();
      int ticket = OrderTicket();
      string symbol = OrderSymbol();
      if (ticket == 0)
      {
         doItAgain = true;
         continue;
      }
      double lots = OrderLots();
      //MessageBox("Order ticket = " + ticket + " lots = " + lots,NULL, EMPTY);
      if (type == OP_BUY)
      {
         if (OrderClose(ticket, lots, MarketInfo(symbol, MODE_BID),  5, CLR_NONE) == false)
         {
            MessageBox("error = " + GetLastError() + " closing ticket " + ticket,NULL,EMPTY);
         }
      }
      else if (type == OP_SELL)
      {
         if (OrderClose(ticket, lots, MarketInfo(symbol, MODE_ASK),  5, CLR_NONE) == false)
         {
            MessageBox("error = " + GetLastError() + " closing ticket " + ticket,NULL,EMPTY);
         }
         
      }
      else
      {
         if (OrderDelete(ticket) == false)
         {
            MessageBox("error = " + GetLastError() + " deleting ticket " + ticket,NULL,EMPTY);
            return (0);
         }
         
      }
      Sleep(1000);
   }
   if (doItAgain == true)
      tryAgain();
   //----
   return(0);
  }